#include "Arduino.h"
#include "SimpleSim800.h"
#include <DebugOverSoftSerial.h>

//This enables debugging mode, to disable it - set value to 0
#define DEBUG 1 

// Spezification of mobile provider
// 1 - 1NCE
// 2 - Vodafone
#define PROVIDER 2

DebugOverSoftSerial gsmDebugLogger;

// alte congstar-Karten
/*
const char _networkAPN[] = "internet.t-mobile";
const char _userName[] = "t-mobile";
const char _passWord[] = "tm";
*/

// neue congstar-Karten
/*
const char _networkAPN[] = "internet.telekom";
const char _userName[] = "congstar";
const char _passWord[] = "cs";
*/

// 1NCE
#if PROVIDER == 1
const char NETWORK_APN[] PROGMEM 					= "iot.1nce.net";
const char NETWORK_USER[] PROGMEM 					= "";
const char NETWORK_PASSWORD[] PROGMEM 				= "";
#endif

// Vodafone IoT Easy Connect NB-IoT
#if PROVIDER == 2
const char NETWORK_APN[] PROGMEM 					= "lpwa.vodafone.com";
const char NETWORK_USER[] PROGMEM 					= "";
const char NETWORK_PASSWORD[] PROGMEM 				= "";
#endif

const char SIM_PIN[] PROGMEM 						= "9545";

const byte DEFAULT_TIMEOUT                          = 5;

const byte COMMAND_SUCCESS                          = 0;
const byte COMMAND_ERROR                            = 1;
const byte COMMAND_TIMEOUT                          = 2;

const byte INIT_SUCCESS 							=  0;
const byte INIT_AT_FAILED						    = 10;
const byte INIT_ENABLE_PHONE_FUNCTIONALITY_FAILED   = 11;
const byte INIT_SUBMIT_PIN_FAILED                   = 12;

const byte CONNECT_SUCCESS							=  0;
const byte CONNECT_NETWORK_FAILED					= 20;
const byte CONNECT_ENABLE_BEARER_FAILED			    = 21;

const byte ENABLE_NTP_FAILED                        = 30;

const byte GET_TIME_SUCCESS                         =  0;
const byte GET_IMEI_SUCCESS                         =  0;
const byte GET_STRENGTH_SUCCESS                     =  0;
const byte GET_ICCID_SUCCESS                        =  0;
const byte POST_DATA_SUCCESS                        =  0;
const byte POST_DATA_FAILED                         = 40;

const byte DISCONNECT_NETWORK_FAILED                = 50;
const byte INIT_DISABLE_PHONE_FUNCTIONALITY_FAILED  = 60;

const char AT[] PROGMEM								= "AT";
const char AT_SAVE_BAUDRATE[] PROGMEM				= "&W";
const char AT_ECHO_OFF[] PROGMEM					= "ATE0";
const char AT_PREFIX[] PROGMEM						= "AT+";
const char AT_BAUDRATE[] PROGMEM					= "IPR=9600";
const char AT_CCLK[] PROGMEM						= "CCLK?";
const char AT_GSN[] PROGMEM							= "GSN";
const char AT_CSQ[] PROGMEM							= "CSQ";
const char AT_CCID[] PROGMEM						= "CCID";
const char AT_HTTPINIT[] PROGMEM					= "HTTPINIT";
const char AT_HTTPTERM[] PROGMEM					= "HTTPTERM";
const char AT_HTTPPARA_CID[] PROGMEM				= "HTTPPARA=CID,1";
const char AT_HTTPPARA_URL_START[] PROGMEM			= "HTTPPARA=\"URL\",\"";
const char AT_HTTPPARA_URL_END[] PROGMEM			= "\"";
const char AT_HTTPPARA_CONTENT_START[] PROGMEM		= "HTTPPARA=\"CONTENT\",\"application/x-www-form-urlencoded";
const char AT_HTTPPARA_CONTENT_END[] PROGMEM		= "\"";
const char AT_HTTPDATA[] PROGMEM					= "HTTPDATA=";
const char AT_HTTPACTION_POST[] PROGMEM				= "HTTPACTION=1";
const char AT_HTTPREAD[] PROGMEM					= "HTTPREAD=0,27";
const char AT_CSCLK_SLEEP[] PROGMEM					= "CSCLK=2";
const char AT_CSCLK_WAKEUP[] PROGMEM				= "CSCLK=0";
const char AT_CFUN_ON[] PROGMEM						= "CFUN=1";
const char AT_CFUN_OFF[] PROGMEM					= "CFUN=0";
const char AT_CPIN_QUERY[] PROGMEM					= "CPIN?";
const char AT_CPIN[] PROGMEM						= "CPIN=";
const char AT_CGATT_QUERY[] PROGMEM					= "CGATT?";
const char AT_CGATT_CONNECT[] PROGMEM				= "CGATT=1";
const char AT_CGATT_DISCONNECT[] PROGMEM			= "CGATT=0";
const char AT_SAPBR_CONNECT[] PROGMEM 				= "SAPBR=1,1";
const char AT_SAPBR_DISCONNECT[] PROGMEM 			= "SAPBR=0,1";
const char AT_SAPBR_OPEN[] PROGMEM					= "SAPBR=3,1,\"Contype\",\"GPRS\"";
const char AT_SAPBR_APN_START[] PROGMEM				= "SAPBR=3,1,\"APN\",\"";
const char AT_SAPBR_APN_END[] PROGMEM				= "\"";
const char AT_SAPBR_USER_START[] PROGMEM			= "SAPBR=3,1,\"USER\",\"";
const char AT_SAPBR_USER_END[] PROGMEM				= "\"";
const char AT_SAPBR_PWD_START[] PROGMEM				= "SAPBR=3,1,\"PWD\",\"";
const char AT_SAPBR_PWD_END[] PROGMEM				= "\"";
const char AT_SAPBR_CONTEXT[] PROGMEM				= "SAPBR=2,1";
const char AT_CREG_QUERY[] PROGMEM					= "CREG?";
const char AT_CNTPCID[] PROGMEM						= "CNTPCID=1";
const char AT_CNTP_SERVER[] PROGMEM 				= "CNTP=\"0.de.pool.ntp.org\",0";
const char AT_CNTP[] PROGMEM						= "CNTP";
const char AT_CCLK_QUERY[] PROGMEM					= "CCLK?";
const char AT_HTTPSCONT[] PROGMEM					= "HTTPSCONT";
const char AT_CGMR[] PROGMEM						= "CGMR";
const char AT_CLBS[] PROGMEM						= "CLBS=1,1";

const char RESPONSE_OK[] PROGMEM					= "OK";
const char RESPONSE_DOWNLOAD[] PROGMEM				= "DOWNLOAD";
const char RESPONSE_HTTP_200[] PROGMEM				= "+HTTPACTION: 1,200";
const char RESPONSE_PIN_ACTIVE[] PROGMEM			= "+CPIN: SIM PIN";
const char RESPONSE_PIN_READY[]	 PROGMEM			= "+CPIN: READY";
const char RESPONSE_CGATT[] PROGMEM					= "+CGATT: 1";
const char RESPONSE_CREG_CONNECTED[] PROGMEM		= "+CREG: 0,1";
const char RESPONSE_CREG_ROAMING[] PROGMEM			= "+CREG: 0,5";
const char RESPONSE_NTP_SUCCESS[] PROGMEM			= "+CNTP: 1";

const char TIMEOUT[] PROGMEM						= "TIMEOUT";


// Initialize the constructors
SimpleSim800::SimpleSim800()
{
	_isModuleConfigured = false;
	_isConnected = false;
}
 
void SimpleSim800::begin()
{
	Serial.begin(9600);
	while (_attention(3) != COMMAND_SUCCESS);
    _attentionDisableEcho();
}

byte SimpleSim800::init()
{
	_isHttpInitialized = false;
	
	if (_attention(3) == COMMAND_ERROR)
	{
		return INIT_AT_FAILED;
	}
	
	_sendCmdAndWaitForResp_P(AT_PREFIX, AT_BAUDRATE, RESPONSE_OK, DEFAULT_TIMEOUT * 2);
	_sendCmdAndWaitForResp_P(AT, AT_SAVE_BAUDRATE, RESPONSE_OK, DEFAULT_TIMEOUT * 2);
	_sendCmdAndWaitForResp_P(AT_PREFIX, AT_CGMR, RESPONSE_OK, DEFAULT_TIMEOUT * 2);
	
    return INIT_SUCCESS;
}

byte SimpleSim800::connect()
{
	if (_isConnected)
	{
		return CONNECT_SUCCESS;
	}
	
	if (_attentionEnablePhoneFunctionality() == COMMAND_ERROR)
	{
		return INIT_ENABLE_PHONE_FUNCTIONALITY_FAILED;
	}
	if (_attentionCheckAndSubmitPin() == COMMAND_ERROR)
	{
		return INIT_SUBMIT_PIN_FAILED;
	}
	
	byte result = _attentionConnectToNetwork();
	if (result == COMMAND_ERROR)
	{
		return CONNECT_NETWORK_FAILED;
	}
	
	result = _attentionEnableBearer();
	if (result == COMMAND_ERROR)
	{
		return CONNECT_ENABLE_BEARER_FAILED;
	}
	
	result = COMMAND_ERROR;
	byte counter = 0;
	do
	{
		result = _attentionConfigureNtp();
		counter++;
	}
	while (result == COMMAND_ERROR && counter < 3);

	_isModuleConfigured = true;
	_isConnected = true;
	return CONNECT_SUCCESS;
}

byte SimpleSim800::disconnect()
{
	_isConnected = false;
	
    if (_attentionDisonnectToNetwork() == COMMAND_ERROR)
	{
		return DISCONNECT_NETWORK_FAILED;
	}
	
    if (_attentionDisablePhoneFunctionality() == COMMAND_ERROR)
	{
		return INIT_DISABLE_PHONE_FUNCTIONALITY_FAILED;
	}
	return COMMAND_SUCCESS;
}

byte SimpleSim800::getDateTime(char* dateTimeString)
{
	_print_P(AT_PREFIX);
	_println_P(AT_CCLK);

    _timerStart = millis();
	
	memset(_serialCharacterBuffer, 0, sizeof(_serialCharacterBuffer));
	
	bool concatToResult = false;
	char c;
	
    while (1) {
        if (Serial.available()) 
		{
            c = Serial.read();
			#if DEBUG
			gsmDebugLogger.print(c);
			#endif
			if (concatToResult)
			{
                if (c == '"')
				{
                    break;
				}
				_serialCharacterBuffer[0] = c;
				strcat(dateTimeString, _serialCharacterBuffer);
			}
            else if (c == '"')
			{
				concatToResult = true;
			}
        }
        _timerEnd = millis();
        if (_timerEnd - _timerStart > 1000) {
			gsmDebugLogger.println_P(TIMEOUT);
            return COMMAND_TIMEOUT;
        }
    }
    _readRemainingCharacters();
	
    return GET_TIME_SUCCESS;
}

byte SimpleSim800::getImei(char* str)
{
	_print_P(AT_PREFIX);
	_println_P(AT_GSN);
	if (_getData(str, true) == COMMAND_ERROR)
	{
		return COMMAND_ERROR;
	}
	_readRemainingCharacters();
	return GET_IMEI_SUCCESS;
}

byte SimpleSim800::getSignalStrength(char* str)
{
	_print_P(AT_PREFIX);
	_println_P(AT_CSQ);
	delay(500);
	if (_getData(str, true) == COMMAND_ERROR)
	{
		return COMMAND_ERROR;
	}
	_readRemainingCharacters();
	return GET_STRENGTH_SUCCESS;
}

byte SimpleSim800::getIccid(char* str)
{
	_print_P(AT_PREFIX);
	_println_P(AT_CCID);
	if (_getData(str, false) == COMMAND_ERROR)
	{
		return COMMAND_ERROR;
	}
	_readRemainingCharacters();
	
	return GET_ICCID_SUCCESS;
}

byte SimpleSim800::postData(const char* url, const char* data)
{
	if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_HTTPINIT, RESPONSE_OK, DEFAULT_TIMEOUT * 3) != COMMAND_SUCCESS)
	{
		if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_HTTPTERM, RESPONSE_OK, DEFAULT_TIMEOUT * 3) != COMMAND_SUCCESS)
		{
			return POST_DATA_FAILED;
		}
		else
		{
			if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_HTTPINIT, RESPONSE_OK, DEFAULT_TIMEOUT * 3) != COMMAND_SUCCESS)
			{
				return POST_DATA_FAILED;
			}
		}
	}
	
	if (!_isHttpInitialized)
	{
		if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_HTTPPARA_CID, RESPONSE_OK, DEFAULT_TIMEOUT * 10) != COMMAND_SUCCESS)
		{
			if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_HTTPTERM, RESPONSE_OK, DEFAULT_TIMEOUT * 3) != COMMAND_SUCCESS)
			{
				return POST_DATA_FAILED;
			}
		}
		
		_print_P(AT_PREFIX);
		_print_P(AT_HTTPPARA_URL_START);
		_print(url);
		if (_sendCmdAndWaitForResp_P(AT_HTTPPARA_URL_END, RESPONSE_OK, DEFAULT_TIMEOUT * 10) != COMMAND_SUCCESS)
		{
			if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_HTTPTERM, RESPONSE_OK, DEFAULT_TIMEOUT * 3) != COMMAND_SUCCESS)
			{
				return POST_DATA_FAILED;
			}
		}
		
		// save settings
		if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_HTTPSCONT, RESPONSE_OK, DEFAULT_TIMEOUT * 10) != COMMAND_SUCCESS)
		{
			if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_HTTPTERM, RESPONSE_OK, DEFAULT_TIMEOUT * 3) != COMMAND_SUCCESS)
			{
				return POST_DATA_FAILED;
			}
		}
		
		_isHttpInitialized = true;
	}
	
	_print_P(AT_PREFIX);
	_print_P(AT_HTTPPARA_CONTENT_START);
	if (_sendCmdAndWaitForResp_P(AT_HTTPPARA_CONTENT_END, RESPONSE_OK, DEFAULT_TIMEOUT * 10) != COMMAND_SUCCESS)
	{
		if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_HTTPTERM, RESPONSE_OK, DEFAULT_TIMEOUT * 3) != COMMAND_SUCCESS)
		{
			return POST_DATA_FAILED;
		}
		return POST_DATA_FAILED;
	}
	
	int dataLength = strlen(data);
	char cstr[10] = {0};
    itoa(dataLength, cstr, 10);
	_print_P(AT_PREFIX);
	_print_P(AT_HTTPDATA);
	strcat(cstr, ",5000");
	_println(cstr);
	if (_waitForResp_P(RESPONSE_DOWNLOAD, DEFAULT_TIMEOUT) != COMMAND_SUCCESS)
	{
		return POST_DATA_FAILED;
	}
	_print(data);
	delay(500);
	_readRemainingCharacters();
	if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_HTTPACTION_POST, RESPONSE_HTTP_200, DEFAULT_TIMEOUT * 10) != COMMAND_SUCCESS)
	{
		delay(1000);
		_readRemainingCharacters();
		if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_HTTPTERM, RESPONSE_OK, DEFAULT_TIMEOUT * 3) != COMMAND_SUCCESS)
		{
			return POST_DATA_FAILED;
		}
		return POST_DATA_FAILED;
	}
	_readRemainingCharacters();
	
	delay(1000);
	_print_P(AT_PREFIX);
	_println_P(AT_HTTPREAD);
	for(byte i = 0; i < 100; i++)
	{
		delay(100);
		if (Serial.available())
		{
			break;
		}
	}
	char c;
	while (Serial.available()) {
		c = Serial.read();
		#if DEBUG
		gsmDebugLogger.print(c);
		#endif
	}

	if (_sendCmdWithRetry_P(AT_PREFIX, AT_HTTPTERM, RESPONSE_OK, DEFAULT_TIMEOUT * 2, 3) != COMMAND_SUCCESS)
	{
		return POST_DATA_FAILED;
	}
	return COMMAND_SUCCESS;
}


byte SimpleSim800::enablePowerSaving()
{
	// return COMMAND_SUCCESS;
	return _sendCmdWithRetry_P(AT_PREFIX, AT_CSCLK_SLEEP, RESPONSE_OK, DEFAULT_TIMEOUT * 2, 3);
}

byte SimpleSim800::disablePowerSaving()
{
	_println_P(AT);
	delay(500);
	_readRemainingCharacters();
	_println_P(AT);
	delay(500);
	_readRemainingCharacters();
	return _sendCmdWithRetry_P(AT_PREFIX, AT_CSCLK_WAKEUP, RESPONSE_OK, DEFAULT_TIMEOUT, 20);
}


byte SimpleSim800::_readBuffer(char* buffer, byte count, byte timeOut) 
{
    int i = 0;
    _timerStart = millis();
	char c;
    while (1) {
        while (Serial.available()) {
            c = Serial.read();
			/*
            if (c == '\r' || c == '\n') {
                c = '$';
            }
			*/
            buffer[i++] = c;
            if (i > count - 1) {
                break;
            }
        }
        if (i > count - 1) {
            break;
        }
        _timerEnd = millis();
        if (_timerEnd - _timerStart > 1000 * timeOut) {
            break;
        }
    }
    #if DEBUG
	gsmDebugLogger.print(buffer);
	#endif
    delay(500);
    while (Serial.available()) {  // display the other thing..
        c = Serial.read();
		#if DEBUG
		gsmDebugLogger.print(c);
		#endif
    }
	
	
    return 0;
}

void SimpleSim800::_cleanBuffer(char* buffer, byte count) 
{
    for (int i = 0; i < count; i++) {
        buffer[i] = '\0';
    }
}

byte SimpleSim800::_waitForResp_P(const char* resp, byte timeout) 
{
	memset(_expectedResponse, 0, sizeof(_expectedResponse));
	strcat_P(_expectedResponse, resp);
	
    int len = strlen(_expectedResponse);
    int sum = 0;
    _timerStart = millis();
	char c;

    while (1) {
        if (Serial.available()) {
            c = Serial.read();
			#if DEBUG
			gsmDebugLogger.print(c);
			#endif
            sum = (c == _expectedResponse[sum]) ? sum + 1 : 0;
            if (sum == len) {
                break;
            }
        }
        _timerEnd = millis();
        if ((_timerEnd - _timerStart > 1000 * timeout) || (_timerEnd < _timerStart)) {
			gsmDebugLogger.println_P(TIMEOUT);
            return COMMAND_TIMEOUT;
        }
    }
    _readRemainingCharacters();

    return 0;
}

uint32_t SimpleSim800::_str_to_ip(const char* str) 
{
    uint32_t ip = 0;
    char* p = (char*)str;

    for (int i = 0; i < 4; i++) 
	{
        ip |= atoi(p);
        p = strchr(p, '.');
        if (p == NULL) 
		{
            break;
        }
        if (i < 3) 
		{
            ip <<= 8;
        }
        p++;
    }
    return ip;
}

byte SimpleSim800::_sendCmdAndWaitForResp_P(const char* prefix, const char* cmd, const char* resp, byte timeout) 
{
    _print_P(prefix);
    return _sendCmdAndWaitForResp_P(cmd, resp, timeout);
}

byte SimpleSim800::_sendCmdAndWaitForResp_P(const char* cmd, const char* resp, byte timeout) 
{
    _println_P(cmd);
    return _waitForResp_P(resp, timeout);
}

void SimpleSim800::_print(const char* cmd)
{
	Serial.print(cmd);
	Serial.flush();
	#if DEBUG
	gsmDebugLogger.print(cmd);
	#endif
}

void SimpleSim800::_println(const char* cmd)
{
	Serial.println(cmd);
	Serial.flush();
	#if DEBUG
	gsmDebugLogger.println(cmd);
	#endif
}

void SimpleSim800::_print_P(const char* cmd)
{
	char c;
	for(int i = 0; ; i++)
    {
        c = pgm_read_byte_near(cmd + i);
	    if (c == 0)
	    {
            break;
	    }
		if (c > 126 || (c < 32 && c != 10 && c != 13))
		{
			char charBuffer[4] = {0};
			itoa(c, charBuffer, 10);
			gsmDebugLogger.print("invalid character: ");
			gsmDebugLogger.println(charBuffer);
		}
	    Serial.print(c);
		#if DEBUG
		gsmDebugLogger.print(c);
		#endif
    }
	Serial.flush();
}

void SimpleSim800::_println_P(const char* cmd)
{
	char c;
	for(int i = 0; ; i++)
    {
        c = pgm_read_byte_near(cmd + i);
	    if (c == 0)
	    {
            break;
	    }
		if (c > 126 || (c < 32 && c != 10 && c != 13))
		{
			char charBuffer[4] = {0};
			itoa(c, charBuffer, 10);
			gsmDebugLogger.print("invalid character: ");
			gsmDebugLogger.println(charBuffer);
		}
	    Serial.print(c);
		#if DEBUG
		gsmDebugLogger.print(c);
		#endif
	}
    Serial.print('\r');
    Serial.print('\n');
	Serial.flush();
	#if DEBUG
	gsmDebugLogger.print('\r');
	gsmDebugLogger.print('\n');
	#endif
}

void SimpleSim800::_readRemainingCharacters()
{
	char c;
	while (Serial.available()) {
        c = Serial.read();
		#if DEBUG
		gsmDebugLogger.print(c);
		#endif
    }
}

byte SimpleSim800::_getData(char* str, bool justNumeric)
{
    _timerStart = millis();
	bool readingData = false;
	char c;
	
	memset(_serialCharacterBuffer, 0, sizeof(_serialCharacterBuffer));
	
	while(1)
	{
        if (Serial.available()) 
		{
            c = Serial.read();
			#if DEBUG
			gsmDebugLogger.print(c);
			#endif
			if (justNumeric)
			{
				if (c == '0' || c == '1' || c == '2' || c == '3' || c == '4' || 
					c == '5' || c == '6' || c == '7' || c == '8' || c == '9')
				{
					readingData = true;
					_serialCharacterBuffer[0] = c;
					strcat(str, _serialCharacterBuffer);
				}
			}
			else
			{
				if (c == '0' || c == '1' || c == '2' || c == '3' || c == '4' || 
					c == '5' || c == '6' || c == '7' || c == '8' || c == '9' ||
					c == 'A' || c == 'B' || c == 'C' || c == 'D' || c == 'E' ||
					c == 'F')
				{
					readingData = true;
					_serialCharacterBuffer[0] = c;
					strcat(str, _serialCharacterBuffer);
				}
			}
            if (readingData && (c == '\r' || c == '\n' || c == ','))
			{
				break;
			}
		}
		_timerEnd = millis();
        if (_timerEnd - _timerStart > DEFAULT_TIMEOUT * 1000 * 3) {
			gsmDebugLogger.println_P(TIMEOUT);
            return COMMAND_TIMEOUT;
        }
	}
	return 0;
}

byte SimpleSim800::_sendCmdWithRetry_P(const char* prefix, const char* cmd, const char* resp, byte timeout, byte retries)
{
	byte loopcounter = 0;
	byte result = 0;
	do {
		result = _sendCmdAndWaitForResp_P(prefix, cmd, resp, timeout);
		loopcounter++;
	}
	while(result != COMMAND_SUCCESS && loopcounter < retries);
	_readRemainingCharacters();
}

byte SimpleSim800::_attention() 
{
    return _attention(1);
}

byte SimpleSim800::_attention(byte timeoutFactor) 
{
    return _sendCmdAndWaitForResp_P(AT, RESPONSE_OK, DEFAULT_TIMEOUT * timeoutFactor);
}

byte SimpleSim800::_attentionDisableEcho()
{
	return _sendCmdAndWaitForResp_P(AT_ECHO_OFF, RESPONSE_OK, DEFAULT_TIMEOUT);
}

byte SimpleSim800::_attentionEnablePhoneFunctionality()
{
	byte result = disablePowerSaving();
    if (result != COMMAND_SUCCESS)
	{
		return result;
	}
		
	// AT_PREFIXCFUN Max Response Time 10 Seconds
	return _sendCmdAndWaitForResp_P(AT_PREFIX, AT_CFUN_ON, RESPONSE_OK, DEFAULT_TIMEOUT * 2);
}

byte SimpleSim800::_attentionDisablePhoneFunctionality()
{
	// AT_PREFIXCFUN Max Response Time 10 Seconds
    if (_sendCmdWithRetry_P(AT_PREFIX, AT_CFUN_OFF, RESPONSE_OK, DEFAULT_TIMEOUT * 5, 3) == COMMAND_ERROR) 
	{
        return COMMAND_ERROR;
    }
	if (enablePowerSaving() == COMMAND_ERROR) 
	{
        return COMMAND_ERROR;
    }
	return COMMAND_SUCCESS;
}

byte SimpleSim800::_attentionCheckAndSubmitPin()
{
	// is PIN deactivated?
	if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_CPIN_QUERY, RESPONSE_PIN_READY, DEFAULT_TIMEOUT) == COMMAND_SUCCESS)
	{
		delay(1000);
		_readRemainingCharacters();
		return COMMAND_SUCCESS;
	}
	
	// is PIN activ?
	if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_CPIN_QUERY, RESPONSE_PIN_ACTIVE, DEFAULT_TIMEOUT) == COMMAND_SUCCESS)
	{
		if (strlen_P(SIM_PIN) > 0)
		{
			_print_P(AT_CPIN);
			if (_sendCmdAndWaitForResp_P(SIM_PIN, RESPONSE_OK, DEFAULT_TIMEOUT * 2) == COMMAND_SUCCESS)
			{
				delay(5000);
				_readRemainingCharacters();
				return COMMAND_SUCCESS;
			}
			else
			{
				_readRemainingCharacters();
				return COMMAND_ERROR;
			}
		}
		else
		{
			return COMMAND_ERROR;
		}
		
	}
	return COMMAND_ERROR;
}

byte SimpleSim800::_attentionConnectToNetwork()
{
	// AT_PREFIXCGATT Max Response Time 10 Seconds
	byte loopCounter = 1;
	do
	{
		if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_CGATT_QUERY, RESPONSE_CGATT, DEFAULT_TIMEOUT * 2) != COMMAND_SUCCESS) 
		{
			if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_CGATT_CONNECT, RESPONSE_OK, DEFAULT_TIMEOUT * 3) == COMMAND_SUCCESS)
			{
				// wait some time
				delay(2000);
				return COMMAND_SUCCESS;
			}
		}	
		else
		{
			_readRemainingCharacters();
			return COMMAND_SUCCESS;
		}
		delay(1000 * loopCounter);
		loopCounter++;
	}
	while (loopCounter < 10);
	return COMMAND_ERROR;
}

byte SimpleSim800::_attentionDisonnectToNetwork()
{
	_sendCmdWithRetry_P(AT_PREFIX, AT_SAPBR_DISCONNECT, RESPONSE_OK, DEFAULT_TIMEOUT * 17, 3);
	
	// AT_PREFIXCGATT Max Response Time 10 Seconds
	return _sendCmdWithRetry_P(AT_PREFIX, AT_CGATT_DISCONNECT, RESPONSE_OK, DEFAULT_TIMEOUT * 5, 5);
}

byte SimpleSim800::_attentionRegistrationState()
{
	// AT_PREFIXCREG? Max Response Time 10 Seconds
	byte counter = 0;
	while(counter < 10)
	{
		if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_CREG_QUERY, RESPONSE_CREG_ROAMING, DEFAULT_TIMEOUT * 2) == COMMAND_SUCCESS) 
		{
			break;
		}
		if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_CREG_QUERY, RESPONSE_CREG_CONNECTED, DEFAULT_TIMEOUT * 2) == COMMAND_SUCCESS) 
		{
			break;
		}
		delay(3000);
		counter++;
	}
	return COMMAND_SUCCESS;
}

byte SimpleSim800::_attentionEnableBearer()
{
	if (_isModuleConfigured == false)
	{
		// Configure bearer profile 1
		// AT_PREFIXSAPBR Max Response Time for open bearer 85 Seconds
		if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_SAPBR_OPEN, RESPONSE_OK, DEFAULT_TIMEOUT) == COMMAND_SUCCESS)
		{
			_print_P(AT_PREFIX);
			_print_P(AT_SAPBR_APN_START);
			_print_P(NETWORK_APN);
			if (_sendCmdAndWaitForResp_P(AT_SAPBR_APN_END, RESPONSE_OK, DEFAULT_TIMEOUT) == COMMAND_SUCCESS)
			{
				if (strlen_P(NETWORK_USER) > 0)
				{
					_print_P(AT_PREFIX);
					_print_P(AT_SAPBR_USER_START);
					_print_P(NETWORK_USER);
					_sendCmdAndWaitForResp_P(AT_SAPBR_USER_END, RESPONSE_OK, DEFAULT_TIMEOUT);
					_print_P(AT_PREFIX);
					_print_P(AT_SAPBR_PWD_START);
					_print_P(NETWORK_PASSWORD);
					_sendCmdAndWaitForResp_P(AT_SAPBR_PWD_END, RESPONSE_OK, DEFAULT_TIMEOUT);
				}
				delay(2000);
			}
			else
			{
				return COMMAND_ERROR;
			}
		}
		else
		{
			return COMMAND_ERROR;
		}
	}
	
	// Open a GPRS context
	if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_SAPBR_CONNECT, RESPONSE_OK, DEFAULT_TIMEOUT * 15) == COMMAND_SUCCESS)
	{
		delay(2000);
		_readRemainingCharacters();
		return _attentionRequestGprsContext();
	}
	else
	{
		_readRemainingCharacters();
		_sendCmdAndWaitForResp_P(AT_PREFIX, AT_SAPBR_DISCONNECT, RESPONSE_OK, DEFAULT_TIMEOUT * 17);
		_readRemainingCharacters();
		
		if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_SAPBR_CONNECT, RESPONSE_OK, DEFAULT_TIMEOUT * 5) == COMMAND_SUCCESS)
		{
			delay(2000);
			_readRemainingCharacters();
			return _attentionRequestGprsContext();
		}
		
		_readRemainingCharacters();
		return COMMAND_ERROR;
	}
    return COMMAND_ERROR;
}

byte SimpleSim800::_attentionRequestGprsContext()
{
	// Query a GPRS context
	return _sendCmdWithRetry_P(AT_PREFIX, AT_SAPBR_CONTEXT, RESPONSE_OK, DEFAULT_TIMEOUT * 15, 3);
}

byte SimpleSim800::_attentionConfigureNtp()
{
	if (_isModuleConfigured == true)
	{
		return COMMAND_SUCCESS;
	}
	if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_CNTPCID, RESPONSE_OK, DEFAULT_TIMEOUT) == COMMAND_SUCCESS)
	{
		if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_CNTP_SERVER, RESPONSE_OK, DEFAULT_TIMEOUT * 3) == COMMAND_SUCCESS)
		{
			if (_sendCmdAndWaitForResp_P(AT_PREFIX, AT_CNTP, RESPONSE_OK, DEFAULT_TIMEOUT * 8) == COMMAND_SUCCESS)
			{
				if(_waitForResp_P(RESPONSE_NTP_SUCCESS, DEFAULT_TIMEOUT * 5) != COMMAND_SUCCESS)
				{
					return COMMAND_ERROR;
				}
				_readRemainingCharacters();
				bool isClockOk = false;
				do
				{
					_print_P(AT_PREFIX);
					_println_P(AT_CCLK_QUERY);
					bool isStartReading = false;
					byte characterCounter = 0;
					char yearBuffer[3] = {0};
					_timerStart = millis();
					char c;
					while(1)
					{
						if (Serial.available()) 
						{
							c = Serial.read();
							#if DEBUG
							gsmDebugLogger.print(c);
							#endif
							if(isStartReading)
							{
								if (c == '0' || c == '1' || c == '2' || c == '3' || c == '4' || 
									c == '5' || c == '6' || c == '7' || c == '8' || c == '9')
								{
									yearBuffer[characterCounter] = c;
									characterCounter++;
								}
							}
							if (c == '0')
							{
								isStartReading = true;
							}
							if (characterCounter = 2)
							{
								break;
							}
						}
						_timerEnd = millis();
						if (_timerEnd - _timerStart > DEFAULT_TIMEOUT * 1000 * 3) 
						{
							gsmDebugLogger.println_P(TIMEOUT);
							_readRemainingCharacters();
							return COMMAND_ERROR;
						}
					}
					_readRemainingCharacters();
					
					// read two characters from date
					int year;
					sscanf(yearBuffer, "%d", &year);
					if (year != 4)
					{
						isClockOk = true;
					}
					delay(2000);
				}
				while(!isClockOk);
        		return COMMAND_SUCCESS;
			}
			// hier ntp wieder abschalten?
			return COMMAND_ERROR;
		}
		return COMMAND_ERROR;
	}	
	return COMMAND_ERROR;
}

boolean SimpleSim800::isSummertime(int year, byte month, byte day, byte hour, byte tzHours)
// European Daylight Savings Time calculation by "jurs" for German Arduino Forum
// input parameters: "normal time" for year, month, day, hour and tzHours (0=UTC, 1=MEZ)
// return value: returns true during Daylight Saving Time, false otherwise
{
  if (month<3 || month>10) 
  {
    return false; // keine Sommerzeit in Jan, Feb, Nov, Dez
  }
  if (month>3 && month<10) 
  {
	return true; // Sommerzeit in Apr, Mai, Jun, Jul, Aug, Sep
  }
  if (month==3 && (hour + 24 * day)>=(1 + tzHours + 24*(31 - (5 * year /4 + 4) % 7)) || month==10 && (hour + 24 * day)<(1 + tzHours + 24*(31 - (5 * year /4 + 1) % 7)))
  {
    return true;
  }
  return false;
}