#ifndef SimpleSim800_h
#define SimpleSim800_h

class SimpleSim800
{
	private:
	
	// member variables
	bool _isModuleConfigured;
	bool _isConnected;
	bool _isHttpInitialized;
	char _serialCharacterBuffer[2];
	char _expectedResponse[20];
	unsigned long _timerStart, _timerEnd;
	
	uint32_t _ip;
	
	// basic mathods for communication
	byte _readBuffer(char* buffer, byte count, byte timeOut);
	void _cleanBuffer(char* buffer, byte count);
	byte _waitForResp_P(const char* resp, byte timeout);
	byte _sendCmdAndWaitForResp_P(const char* prefix, const char* cmd, const char* resp, byte timeout);
	byte _sendCmdAndWaitForResp_P(const char* cmd, const char* resp, byte timeout);
	void _print(const char* cmd);
	void _println(const char* cmd);
	void _print_P(const char* cmd);
	void _println_P(const char* cmd);
	void _readRemainingCharacters();
	byte _getData(char* str, bool justNumeric);
	byte _sendCmdWithRetry_P(const char* prefix, const char* cmd, const char* resp, byte timeout, byte retries);

    // helper methods
    uint32_t _str_to_ip(const char* str);

    // methods für basic settings
    byte _attention();
	byte _attention(byte timeoutFactor);
	byte _attentionDisableEcho();
	byte _attentionEnablePhoneFunctionality();
	byte _attentionDisablePhoneFunctionality();
	byte _attentionCheckAndSubmitPin();
	byte _attentionRegistrationState();
	byte _attentionConnectToNetwork();
	byte _attentionDisonnectToNetwork();
	byte _attentionEnableBearer();
	byte _attentionRequestGprsContext();
	byte _attentionConfigureNtp();
	
	public:
	SimpleSim800();
	
	void begin();
	byte init();
	byte connect();
	byte disconnect();
	byte enablePowerSaving();
	byte disablePowerSaving();

	byte getDateTime(char* str);
	bool isSummertime(int year, byte month, byte day, byte hour, byte tzHours);
	
	byte getImei(char* str);
	byte getSignalStrength(char* str);
	byte getIccid(char* str);
	
	byte postData(const char* url, const char* data);
};

 #endif